# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from play_motion_builder_msgs/EditMotionRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class EditMotionRequest(genpy.Message):
  _md5sum = "994d269af2f608a6b9a823b10da14d7d"
  _type = "play_motion_builder_msgs/EditMotionRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Definitions of actions
uint8 LIST=0
uint8 APPEND=1
uint8 EDIT=2
uint8 COPY_AS_NEXT=3
uint8 COPY_AS_LAST=4
uint8 REMOVE=5
uint8 EDIT_TIME=6

# Step id for the step to which the action should be applied
uint16 step_id
# Action to execute
uint8 action
# Time to be set (only used if action is EDIT_TIME)
float32 time
"""
  # Pseudo-constants
  LIST = 0
  APPEND = 1
  EDIT = 2
  COPY_AS_NEXT = 3
  COPY_AS_LAST = 4
  REMOVE = 5
  EDIT_TIME = 6

  __slots__ = ['step_id','action','time']
  _slot_types = ['uint16','uint8','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       step_id,action,time

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EditMotionRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.step_id is None:
        self.step_id = 0
      if self.action is None:
        self.action = 0
      if self.time is None:
        self.time = 0.
    else:
      self.step_id = 0
      self.action = 0
      self.time = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_HBf().pack(_x.step_id, _x.action, _x.time))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 7
      (_x.step_id, _x.action, _x.time,) = _get_struct_HBf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_HBf().pack(_x.step_id, _x.action, _x.time))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 7
      (_x.step_id, _x.action, _x.time,) = _get_struct_HBf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_HBf = None
def _get_struct_HBf():
    global _struct_HBf
    if _struct_HBf is None:
        _struct_HBf = struct.Struct("<HBf")
    return _struct_HBf
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from play_motion_builder_msgs/EditMotionResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import play_motion_builder_msgs.msg

class EditMotionResponse(genpy.Message):
  _md5sum = "b8977f11190208bf644de5781a8adaa9"
  _type = "play_motion_builder_msgs/EditMotionResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# True if no issues ocurred during the call
bool ok
# Error message in case an issue occurred during the call
string message
# Current state of the motion
play_motion_builder_msgs/Motion motion


================================================================================
MSG: play_motion_builder_msgs/Motion
# List of joint names, keyframe positions are ordered based on this list
string[] joints
# List of Frames
play_motion_builder_msgs/Frame[] keyframes
# Name of the joint group used during this motion
string used_group

================================================================================
MSG: play_motion_builder_msgs/Frame
# Array with joint poses
float64[] pose
# Time since last Frame
float32 time_from_last"""
  __slots__ = ['ok','message','motion']
  _slot_types = ['bool','string','play_motion_builder_msgs/Motion']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       ok,message,motion

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EditMotionResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.ok is None:
        self.ok = False
      if self.message is None:
        self.message = ''
      if self.motion is None:
        self.motion = play_motion_builder_msgs.msg.Motion()
    else:
      self.ok = False
      self.message = ''
      self.motion = play_motion_builder_msgs.msg.Motion()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.ok
      buff.write(_get_struct_B().pack(_x))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.motion.joints)
      buff.write(_struct_I.pack(length))
      for val1 in self.motion.joints:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.motion.keyframes)
      buff.write(_struct_I.pack(length))
      for val1 in self.motion.keyframes:
        length = len(val1.pose)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.Struct(pattern).pack(*val1.pose))
        _x = val1.time_from_last
        buff.write(_get_struct_f().pack(_x))
      _x = self.motion.used_group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.motion is None:
        self.motion = play_motion_builder_msgs.msg.Motion()
      end = 0
      start = end
      end += 1
      (self.ok,) = _get_struct_B().unpack(str[start:end])
      self.ok = bool(self.ok)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.motion.joints = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.motion.joints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.motion.keyframes = []
      for i in range(0, length):
        val1 = play_motion_builder_msgs.msg.Frame()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.pose = s.unpack(str[start:end])
        start = end
        end += 4
        (val1.time_from_last,) = _get_struct_f().unpack(str[start:end])
        self.motion.keyframes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.motion.used_group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.motion.used_group = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.ok
      buff.write(_get_struct_B().pack(_x))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.motion.joints)
      buff.write(_struct_I.pack(length))
      for val1 in self.motion.joints:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.motion.keyframes)
      buff.write(_struct_I.pack(length))
      for val1 in self.motion.keyframes:
        length = len(val1.pose)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.pose.tostring())
        _x = val1.time_from_last
        buff.write(_get_struct_f().pack(_x))
      _x = self.motion.used_group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.motion is None:
        self.motion = play_motion_builder_msgs.msg.Motion()
      end = 0
      start = end
      end += 1
      (self.ok,) = _get_struct_B().unpack(str[start:end])
      self.ok = bool(self.ok)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.motion.joints = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.motion.joints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.motion.keyframes = []
      for i in range(0, length):
        val1 = play_motion_builder_msgs.msg.Frame()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.pose = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (val1.time_from_last,) = _get_struct_f().unpack(str[start:end])
        self.motion.keyframes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.motion.used_group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.motion.used_group = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
class EditMotion(object):
  _type          = 'play_motion_builder_msgs/EditMotion'
  _md5sum = '85e84c3afe79c9be731c7f83946f6b7b'
  _request_class  = EditMotionRequest
  _response_class = EditMotionResponse
